import { createHash } from 'crypto';
import { AssistantPath, File } from '../util/index.js';
class Security {
    async loadAuthorizedUsers() {
        const fileInstance = new File('.server.credentials.json', AssistantPath.getCredentialPath());
        const credentialsStr = await fileInstance.read();
        const credentialsJson = JSON.parse(credentialsStr);
        if (credentialsJson && credentialsJson.authorized_users) {
            process.env.AUTHORIZED_USERS = JSON.stringify(credentialsJson.authorized_users);
        }
    }
    async isAuthorizedUser(username, password) {
        if (!process.env.AUTHORIZED_USERS) {
            await this.loadAuthorizedUsers();
        }
        const users = process.env.AUTHORIZED_USERS ? JSON.parse(process.env.AUTHORIZED_USERS) : {};
        if (!users || !users[username])
            return false;
        const passwordToVerify = createHash('sha256').update(password).digest('hex');
        const storedPassword = users[username];
        return storedPassword === passwordToVerify;
    }
}
const instance = new Security();
export { instance as Security };
export default instance;
